Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 7567)
@@ -22,4 +22,6 @@
    USE timing          ! Timing
    USE trc_oce, ONLY : lk_offline ! offline flag
+   USE lbclnk 
+   USE eosbn2          ! Equation of state
 
    IMPLICIT NONE
@@ -27,4 +29,5 @@
 
    PUBLIC   zdf_mxl       ! called by step.F90
+   PUBLIC   zdf_mxl_tref  ! called by asminc.F90
    PUBLIC   zdf_mxl_alloc ! Used in zdf_tke_init
 
@@ -33,7 +36,26 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlp    !: mixed layer depth  (rho=rho0+zdcrit) [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlpt   !: mixed layer depth at t-points        [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmld_tref  !: mixed layer depth at t-points - temperature criterion [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmld_kara  !: mixed layer depth of Kara et al   [m]
 
    REAL(wp), PUBLIC ::   rho_c = 0.01_wp    !: density criterion for mixed layer depth
    REAL(wp)         ::   avt_c = 5.e-4_wp   ! Kz criterion for the turbocline depth
+
+   ! Namelist variables for  namzdf_karaml 
+ 
+   LOGICAL   :: ln_kara            ! Logical switch for calculating kara mixed
+                                     ! layer
+   LOGICAL   :: ln_kara_write25h   ! Logical switch for 25 hour outputs
+   INTEGER   :: jpmld_type         ! mixed layer type             
+   REAL(wp)  :: ppz_ref            ! depth of initial T_ref 
+   REAL(wp)  :: ppdT_crit          ! Critical temp diff  
+   REAL(wp)  :: ppiso_frac         ! Fraction of ppdT_crit used 
+   
+   !Used for 25h mean
+   LOGICAL, PRIVATE :: kara_25h_init = .TRUE.   !Logical used to initalise 25h 
+                                                !outputs. Necissary, because we need to
+                                                !initalise the kara_25h on the zeroth
+                                                !timestep (i.e in the nemogcm_init call)
+   REAL, PRIVATE, ALLOCATABLE, DIMENSION(:,:) :: hmld_kara_25h
 
    !! * Substitutions
@@ -52,5 +74,6 @@
       zdf_mxl_alloc = 0      ! set to zero if no array to be allocated
       IF( .NOT. ALLOCATED( nmln ) ) THEN
-         ALLOCATE( nmln(jpi,jpj), hmld(jpi,jpj), hmlp(jpi,jpj), hmlpt(jpi,jpj), STAT= zdf_mxl_alloc )
+         ALLOCATE( nmln(jpi,jpj), hmld(jpi,jpj), hmlp(jpi,jpj), hmlpt(jpi,jpj), &
+         &                           hmld_tref(jpi,jpj), STAT= zdf_mxl_alloc )
          !
          IF( lk_mpp             )   CALL mpp_sum ( zdf_mxl_alloc )
@@ -123,4 +146,7 @@
       END DO
       ! depth of the mixing and mixed layers
+
+      CALL zdf_mxl_kara( kt ) ! kara MLD
+
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -146,4 +172,293 @@
    END SUBROUTINE zdf_mxl
 
+
+   SUBROUTINE zdf_mxl_tref()
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE zdf_mxl_tref  ***
+      !!                   
+      !! ** Purpose :   Compute the mixed layer depth with temperature criteria.
+      !!
+      !! ** Method  :   The temperature-defined mixed layer depth is required
+      !!                   when assimilating SST in a 2D analysis. 
+      !!
+      !! ** Action  :   hmld_tref
+      !!----------------------------------------------------------------------
+      !
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   t_ref               ! Reference temperature  
+      REAL(wp) ::   temp_c = 0.2        ! temperature criterion for mixed layer depth  
+      !!----------------------------------------------------------------------
+      !
+      ! Initialise array
+      IF( zdf_mxl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_mxl_tref : unable to allocate arrays' )
+      
+      !For the AMM model assimiation uses a temperature based mixed layer depth  
+      !This is defined here  
+      DO jj = 1, jpj  
+         DO ji = 1, jpi  
+           hmld_tref(ji,jj)=fsdept(ji,jj,1  )   
+           IF(ssmask(ji,jj) > 0.)THEN  
+             t_ref=tsn(ji,jj,1,jp_tem) 
+             DO jk=2,jpk  
+               IF(ssmask(ji,jj)==0.)THEN  
+                  hmld_tref(ji,jj)=fsdept(ji,jj,jk )  
+                  EXIT  
+               ELSEIF( ABS(tsn(ji,jj,jk,jp_tem)-t_ref) < temp_c)THEN  
+                  hmld_tref(ji,jj)=fsdept(ji,jj,jk )  
+               ELSE  
+                  EXIT  
+               ENDIF  
+             ENDDO  
+           ENDIF  
+         ENDDO  
+      ENDDO
+
+   END SUBROUTINE zdf_mxl_tref
+
+   SUBROUTINE zdf_mxl_kara( kt ) 
+      !!---------------------------------------------------------------------------------- 
+      !!                    ***  ROUTINE zdf_mxl_kara  *** 
+      !                                                                        
+      !   Calculate mixed layer depth according to the definition of          
+      !   Kara et al, 2000, JGR, 105, 16803.  
+      ! 
+      !   If mld_type=1 the mixed layer depth is calculated as the depth at which the  
+      !   density has increased by an amount equivalent to a temperature difference of  
+      !   0.8C at the surface. 
+      ! 
+      !   For other values of mld_type the mixed layer is calculated as the depth at  
+      !   which the temperature differs by 0.8C from the surface temperature.  
+      !                                                                        
+      !   Original version: David Acreman                                      
+      ! 
+      !!-----------------------------------------------------------------------------------
+     
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index 
+ 
+      NAMELIST/namzdf_karaml/ ln_kara,jpmld_type, ppz_ref, ppdT_crit, &
+      &                       ppiso_frac, ln_kara_write25h 
+ 
+      ! Local variables                                                        
+      REAL, DIMENSION(jpi,jpk) :: ppzdep      ! depth for use in calculating d(rho) 
+      REAL(wp), DIMENSION(jpi,jpj,jpts) :: ztsn_2d  !Local version of tsn 
+      LOGICAL :: ll_found(jpi,jpj)              ! Is T_b to be found by interpolation ? 
+      LOGICAL :: ll_belowml(jpi,jpj,jpk)        ! Flag points below mixed layer when ll_found=F 
+      INTEGER :: ji, jj, jk                     ! loop counter 
+      INTEGER :: ik_ref(jpi,jpj)                ! index of reference level 
+      INTEGER :: ik_iso(jpi,jpj)                ! index of last uniform temp level 
+      REAL    :: zT(jpi,jpj,jpk)                ! Temperature or denisty 
+      REAL    :: zT_ref(jpi,jpj)                ! reference temperature 
+      REAL    :: zT_b                           ! base temperature 
+      REAL    :: zdTdz(jpi,jpj,jpk-2)           ! gradient of zT 
+      REAL    :: zmoddT(jpi,jpj,jpk-2)          ! Absolute temperature difference 
+      REAL    :: zdz                            ! depth difference 
+      REAL    :: zdT                            ! temperature difference 
+      REAL    :: zdelta_T(jpi,jpj)              ! difference critereon 
+      REAL    :: zRHO1(jpi,jpj), zRHO2(jpi,jpj) ! Densities
+      INTEGER, SAVE :: idt, i_steps
+      INTEGER, SAVE :: i_cnt_25h     ! Counter for 25 hour means
+      INTEGER :: ios                 ! Local integer output status for namelist read
+
+     
+ 
+      !!------------------------------------------------------------------------------------- 
+ 
+      IF( kt == nit000 ) THEN 
+         ! Default values 
+         ln_kara      = .FALSE.
+         ln_kara_write25h = .FALSE. 
+         jpmld_type   = 1     
+         ppz_ref      = 10.0 
+         ppdT_crit    = 0.2  
+         ppiso_frac   = 0.1   
+         ! Read namelist
+         REWIND ( numnam_ref )
+         READ   ( numnam_ref, namzdf_karaml, IOSTAT=ios, ERR= 901 )
+901      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzdf_karaml in reference namelist', lwp )
+
+         REWIND( numnam_cfg )              ! Namelist nam_diadiaop in configuration namelist  3D hourly diagnostics
+         READ  ( numnam_cfg,  namzdf_karaml, IOSTAT = ios, ERR = 902 )
+902      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzdf_karaml in configuration namelist', lwp )
+         IF(lwm) WRITE ( numond, namzdf_karaml )
+ 
+
+         WRITE(numout,*) '===== Kara mixed layer =====' 
+         WRITE(numout,*) 'ln_kara = ',    ln_kara
+         WRITE(numout,*) 'jpmld_type = ', jpmld_type 
+         WRITE(numout,*) 'ppz_ref = ',    ppz_ref 
+         WRITE(numout,*) 'ppdT_crit = ',  ppdT_crit 
+         WRITE(numout,*) 'ppiso_frac = ', ppiso_frac
+         WRITE(numout,*) 'ln_kara_write25h = ', ln_kara_write25h
+         WRITE(numout,*) '============================' 
+      
+         IF ( .NOT.ln_kara ) THEN
+            WRITE(numout,*) "ln_kara not set; Kara mixed layer not calculated" 
+         ELSE
+            IF (.NOT. ALLOCATED(hmld_kara) ) ALLOCATE( hmld_kara(jpi,jpj) )
+            IF ( ln_kara_write25h .AND. kara_25h_init ) THEN
+               i_cnt_25h = 0
+               IF (.NOT. ALLOCATED(hmld_kara_25h) ) &
+               &   ALLOCATE( hmld_kara_25h(jpi,jpj) )
+               hmld_kara_25h = 0._wp
+               IF( nacc == 1 ) THEN
+                  idt = INT(rdtmin)
+               ELSE
+                  idt = INT(rdt)
+               ENDIF
+               IF( MOD( 3600,idt) == 0 ) THEN 
+                  i_steps = 3600 / idt  
+               ELSE 
+                  CALL ctl_stop('STOP', &
+                  & 'zdf_mxl_kara: timestep must give MOD(3600,rdt)'// &
+                  & ' = 0 otherwise no hourly values are possible') 
+               ENDIF  
+            ENDIF
+         ENDIF
+      ENDIF
+      
+      IF ( ln_kara ) THEN
+         
+         !set critical ln_kara
+         ztsn_2d = tsn(:,:,1,:)
+         ztsn_2d(:,:,jp_tem) = ztsn_2d(:,:,jp_tem) + ppdT_crit
+     
+         ! Set the mixed layer depth criterion at each grid point 
+         ppzdep = 0._wp
+         IF( jpmld_type == 1 ) THEN                                         
+            CALL eos ( tsn(:,:,1,:), &
+            &          ppzdep(:,:), zRHO1(:,:) ) 
+            CALL eos ( ztsn_2d(:,:,:), &
+            &           ppzdep(:,:), zRHO2(:,:) ) 
+            zdelta_T(:,:) = abs( zRHO1(:,:) - zRHO2(:,:) ) * rau0 
+            ! RHO from eos (2d version) doesn't calculate north or east halo: 
+            CALL lbc_lnk( zdelta_T, 'T', 1. ) 
+            zT(:,:,:) = rhop(:,:,:) 
+         ELSE 
+            zdelta_T(:,:) = ppdT_crit                      
+            zT(:,:,:) = tsn(:,:,:,jp_tem)                           
+         ENDIF 
+     
+         ! Calculate the gradient of zT and absolute difference for use later 
+         DO jk = 1 ,jpk-2 
+            zdTdz(:,:,jk)  =    ( zT(:,:,jk+1) - zT(:,:,jk) ) / fse3w(:,:,jk+1) 
+            zmoddT(:,:,jk) = abs( zT(:,:,jk+1) - zT(:,:,jk) ) 
+         END DO 
+     
+         ! Find density/temperature at the reference level (Kara et al use 10m).          
+         ! ik_ref is the index of the box centre immediately above or at the reference level 
+         ! Find ppz_ref in the array of model level depths and find the ref    
+         ! density/temperature by linear interpolation.                                   
+         ik_ref = -1
+         DO jk = jpkm1, 2, -1 
+            WHERE( fsdept(:,:,jk) > ppz_ref ) 
+               ik_ref(:,:) = jk - 1 
+               zT_ref(:,:) = zT(:,:,jk-1) + &
+               &             zdTdz(:,:,jk-1) * ( ppz_ref - fsdept(:,:,jk-1) ) 
+            ENDWHERE 
+         END DO
+         IF ( ANY( ik_ref  < 0 ) .OR. ANY( ik_ref  > jpkm1 ) ) THEN
+            CALL ctl_stop( "STOP", &
+            & "zdf_mxl_kara: unable to find reference level for kara ML" ) 
+         ELSE
+            ! If the first grid box centre is below the reference level then use the 
+            ! top model level to get zT_ref 
+            WHERE( fsdept(:,:,1) > ppz_ref )  
+               zT_ref = zT(:,:,1) 
+               ik_ref = 1 
+            ENDWHERE 
+     
+            ! Search for a uniform density/temperature region where adjacent levels          
+            ! differ by less than ppiso_frac * deltaT.                                      
+            ! ik_iso is the index of the last level in the uniform layer  
+            ! ll_found indicates whether the mixed layer depth can be found by interpolation 
+            ik_iso(:,:)   = ik_ref(:,:) 
+            ll_found(:,:) = .false. 
+            DO jj = 1, nlcj 
+               DO ji = 1, nlci 
+                 !CDIR NOVECTOR 
+                  DO jk = ik_ref(ji,jj), mbathy(ji,jj)-1 
+                     IF( zmoddT(ji,jj,jk) > ( ppiso_frac * zdelta_T(ji,jj) ) ) THEN 
+                        ik_iso(ji,jj)   = jk 
+                        ll_found(ji,jj) = ( zmoddT(ji,jj,jk) > zdelta_T(ji,jj) ) 
+                        EXIT 
+                     ENDIF 
+                  END DO 
+               END DO 
+            END DO 
+     
+            ! Use linear interpolation to find depth of mixed layer base where possible 
+            hmld_kara(:,:) = ppz_ref 
+            DO jj = 1, jpj 
+               DO ji = 1, jpi 
+                  IF( ll_found(ji,jj) .and. tmask(ji,jj,1) == 1.0 ) THEN 
+                     zdz =  abs( zdelta_T(ji,jj) / zdTdz(ji,jj,ik_iso(ji,jj)) ) 
+                     hmld_kara(ji,jj) = fsdept(ji,jj,ik_iso(ji,jj)) + zdz 
+                  ENDIF 
+               END DO 
+            END DO 
+     
+            ! If ll_found = .false. then calculate MLD using difference of zdelta_T    
+            ! from the reference density/temperature 
+     
+            ! Prevent this section from working on land points 
+            WHERE( tmask(:,:,1) /= 1.0 ) 
+               ll_found = .true. 
+            ENDWHERE 
+     
+            DO jk = 1, jpk 
+               ll_belowml(:,:,jk) = abs( zT(:,:,jk) - zT_ref(:,:) ) >= &
+               & zdelta_T(:,:)
+            END DO 
+     
+            ! Set default value where interpolation cannot be used (ll_found=false)  
+            DO jj = 1, jpj 
+               DO ji = 1, jpi 
+                  IF( .NOT. ll_found(ji,jj) )  &
+                  &   hmld_kara(ji,jj) = fsdept(ji,jj,mbathy(ji,jj)) 
+               END DO 
+            END DO 
+     
+            DO jj = 1, jpj 
+               DO ji = 1, jpi 
+                  !CDIR NOVECTOR 
+                  DO jk = ik_ref(ji,jj)+1, mbathy(ji,jj) 
+                     IF( ll_found(ji,jj) ) EXIT 
+                     IF( ll_belowml(ji,jj,jk) ) THEN                
+                        zT_b = zT_ref(ji,jj) + zdelta_T(ji,jj) * &
+                        &      SIGN(1.0, zdTdz(ji,jj,jk-1) ) 
+                        zdT  = zT_b - zT(ji,jj,jk-1)                                      
+                        zdz  = zdT / zdTdz(ji,jj,jk-1)                                       
+                        hmld_kara(ji,jj) = fsdept(ji,jj,jk-1) + zdz 
+                        EXIT                                                   
+                     ENDIF 
+                  END DO 
+               END DO 
+            END DO 
+     
+            hmld_kara(:,:) = hmld_kara(:,:) * tmask(:,:,1) 
+ 
+            IF(  ln_kara_write25h  ) THEN
+               !Double IF required as i_steps not defined if ln_kara_write25h =
+               ! FALSE
+               IF ( ( MOD( kt, i_steps ) == 0 ) .OR.  kara_25h_init ) THEN
+                  hmld_kara_25h = hmld_kara_25h + hmld_kara
+                  i_cnt_25h = i_cnt_25h + 1
+                  IF ( kara_25h_init ) kara_25h_init = .FALSE.
+               ENDIF
+            ENDIF
+ 
+#if defined key_iomput 
+            IF( kt /= nit000 ) THEN 
+               CALL iom_put( "mldkara"  , hmld_kara )   
+               IF( ( MOD( i_cnt_25h, 25) == 0 ) .AND.  ln_kara_write25h ) &
+                  CALL iom_put( "kara25h"  , ( hmld_kara_25h / 25._wp ) )
+            ENDIF
+#endif
+ 
+         ENDIF
+      ENDIF
+       
+   END SUBROUTINE zdf_mxl_kara 
+
    !!======================================================================
 END MODULE zdfmxl
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7567)
@@ -85,4 +85,8 @@
    USE stopar
    USE stopts
+   USE diatmb          ! Top,middle,bottom output
+   USE diaregmean      ! Top,middle,bottom output
+   USE diapea          ! Top,middle,bottom output
+   USE dia25h          ! 25h mean output
 
    IMPLICIT NONE
@@ -475,4 +479,13 @@
       IF( lk_asminc     )   CALL asm_inc_init   ! Initialize assimilation increments
       IF(lwp) WRITE(numout,*) 'Euler time step switch is ', neuler
+                            CALL dia_tmb_init  ! TMB outputs
+                            CALL mpp_max( nstop )
+                            !write(*,*) nstop, narea, 'nstop nemogcm before dia_regmean_init'
+                             
+                            CALL dia_regmean_init  ! TMB outputs
+                            CALL dia_pea_init  ! TMB outputs
+                            CALL mpp_max( nstop )
+                            !write(*,*)  nstop, narea, 'nstop nemogcm finished dia_regmean_init'
+                            CALL dia_25h_init  ! 25h mean  outputs
       !
    END SUBROUTINE nemo_init
@@ -608,6 +621,11 @@
       IF( numout          /=  6 )   CLOSE( numout          )   ! standard model output file
       IF( numdct_vol      /= -1 )   CLOSE( numdct_vol      )   ! volume transports
-      IF( numdct_heat     /= -1 )   CLOSE( numdct_heat     )   ! heat transports
-      IF( numdct_salt     /= -1 )   CLOSE( numdct_salt     )   ! salt transports
+      !JT IF( numdct_heat     /= -1 )   CLOSE( numdct_heat     )   ! heat transports
+      !JT IF( numdct_salt     /= -1 )   CLOSE( numdct_salt     )   ! salt transports
+      IF( numdct_vol  /= -1 )   CLOSE( numdct_vol  )   ! volume transports
+      IF( numdct_temp /= -1 )   CLOSE( numdct_temp )   ! heat transports
+      IF( numdct_sal  /= -1 )   CLOSE( numdct_sal  )   ! salt transports
+      IF( numdct_NOOS /= -1 )   CLOSE( numdct_NOOS )   ! NOOS transports
+
 
       !
@@ -630,4 +648,5 @@
       USE ldftra_oce, ONLY: ldftra_oce_alloc
       USE trc_oce   , ONLY: trc_oce_alloc
+      USE diainsitutem, ONLY: insitu_tem_alloc
 #if defined key_diadct 
       USE diadct    , ONLY: diadct_alloc 
@@ -646,4 +665,5 @@
       ierr = ierr + ldftra_oce_alloc()          ! ocean lateral  physics : tracers
       ierr = ierr + zdf_oce_alloc   ()          ! ocean vertical physics
+      ierr = ierr + insitu_tem_alloc()
       !
       ierr = ierr + trc_oce_alloc   ()          ! shared TRC / TRA arrays
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7567)
@@ -255,4 +255,5 @@
                              CALL tra_sbc    ( kstp )       ! surface boundary condition
       IF( ln_traqsr      )   CALL tra_qsr    ( kstp )       ! penetrative solar radiation qsr
+      IF( ln_tradwl      )   CALL tra_dwl    ( kstp )       ! Polcoms Style Short Wave Radiation 
       IF( ln_trabbc      )   CALL tra_bbc    ( kstp )       ! bottom heat flux
       IF( lk_trabbl      )   CALL tra_bbl    ( kstp )       ! advective (and/or diffusive) bottom boundary layer scheme
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7567)
@@ -25,4 +25,5 @@
    USE sbcrnf           ! surface boundary condition: runoff variables
    USE sbccpl           ! surface boundary condition: coupled formulation (call send at end of step)
+   USE sbcflx           ! surface boundary condition: Fluxes
    USE sbc_oce          ! surface boundary condition: ocean
    USE sbctide          ! Tide initialisation
@@ -30,4 +31,5 @@
 
    USE traqsr           ! solar radiation penetration      (tra_qsr routine)
+   USE tradwl           ! POLCOMS style solar radiation    (tra_dwl routine) 
    USE trasbc           ! surface boundary condition       (tra_sbc routine)
    USE trabbc           ! bottom boundary condition        (tra_bbc routine)
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/OPA_SRC/trc_oce.F90	(revision 7567)
@@ -27,4 +27,6 @@
    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   etot3         !: light absortion coefficient
    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   facvol        !: volume for degraded regions
+   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   rlambda2      !: Lambda2 for downwell version of Short wave Radiation
+   REAL(wp), PUBLIC                                      ::   rlambda       !: Lambda  for downwell version of Short wave Radiation
 
 #if defined key_top 
@@ -78,12 +80,14 @@
       !!                  ***  trc_oce_alloc  ***
       !!----------------------------------------------------------------------
-      INTEGER ::   ierr(2)        ! Local variables
+      INTEGER ::   ierr(3)        ! Local variables
       !!----------------------------------------------------------------------
       ierr(:) = 0
                      ALLOCATE( etot3 (jpi,jpj,jpk), STAT=ierr(1) )
       IF( lk_degrad) ALLOCATE( facvol(jpi,jpj,jpk), STAT=ierr(2) )
+                    ALLOCATE( rlambda2(jpi,jpj),   STAT=ierr(3) )
       trc_oce_alloc  = MAXVAL( ierr )
       !
       IF( trc_oce_alloc /= 0 )   CALL ctl_warn('trc_oce_alloc: failed to allocate etot3 array')
+      IF( trc_oce_alloc /= 0 )   CALL ctl_warn('trc_oce_alloc: failed to allocate etot3, facvol or rlambda2 array')
    END FUNCTION trc_oce_alloc
 
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 7567)
@@ -18,4 +18,5 @@
    USE trd_oce
    USE trdtrc
+   USE trcbc, only : trc_bc_read
 
    IMPLICIT NONE
@@ -55,4 +56,6 @@
 
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrmyt )
+
+      CALL trc_bc_read  ( kt )       ! tracers: surface and lateral Boundary Conditions
 
       IF( l_trdtrc ) THEN      ! Save the trends in the ixed layer
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 7567)
@@ -19,9 +19,17 @@
 
    PUBLIC trc_wri_my_trc 
+#if defined key_tracer_budget
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), SAVE :: trb_temp ! slwa
+#endif
+
 
 #  include "top_substitute.h90"
 CONTAINS
 
+#if defined key_tracer_budget
+   SUBROUTINE trc_wri_my_trc (kt, fl) ! slwa
+#else
    SUBROUTINE trc_wri_my_trc
+#endif
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE trc_wri_trc  ***
@@ -29,14 +37,67 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
+#if defined key_tracer_budget
+      INTEGER, INTENT( in ), OPTIONAL     :: fl 
+      INTEGER, INTENT( in )               :: kt
+      REAL(wp), DIMENSION(jpi,jpj,jpk)    :: trpool !tracer pool temporary output
+#endif
       CHARACTER (len=20)   :: cltra
-      INTEGER              :: jn
+      INTEGER              :: jn,jk
       !!---------------------------------------------------------------------
  
       ! write the tracer concentrations in the file
       ! ---------------------------------------
+
+
+#if defined key_tracer_budget
+      IF( PRESENT(fl)) THEN
+! depth integrated
+! for strict budgetting write this out at end of timestep as an average between 'now' and 'after' at kt
+         DO jn = jp_myt0, jp_myt1 
+            trpool(:,:,:) = 0.5 * ( trn(:,:,:,jn) * fse3t_a(:,:,:) +  &
+                                        trb_temp(:,:,:,jn) * fse3t(:,:,:) )
+!
+            cltra = TRIM( ctrcnm(jn) )                  ! output of tracer density 
+            CALL iom_put( cltra, trpool(:,:,:) / (0.5* (fse3t(:,:,:) + fse3t_a(:,:,:) ) ) )
+!
+            cltra = TRIM( ctrcnm(jn) )//"_pool"     ! volume integrated output
+            DO jk = 1, jpk
+               trpool(:,:,jk) = trpool(:,:,jk) * e1t(:,:) * e2t(:,:)
+            END DO
+            CALL iom_put( cltra, trpool)
+
+!           cltra = TRIM( ctrcnm(jn) )//"_pool"     ! volume integrated output
+!           DO jk = 1, jpk
+!              trpool(:,:,jk) = 0.5 * ( trn(:,:,jk,jn) * fse3t_a(:,:,jk) +  & 
+!                                       trb_temp(:,:,jk,jn) * fse3t(:,:,jk) ) * & 
+!                                       e1t(:,:) * e2t(:,:)
+!           END DO
+!           CALL iom_put( cltra, trpool)
+!           cltra = TRIM( ctrcnm(jn) )                  ! output of tracer density 
+!           CALL iom_put( cltra, trpool(:,:,:) / (0.5* (fse3t(:,:,:) + fse3t_a(:,:,:) ) ) )
+         END DO
+         CALL iom_put( "DEPTH" , 0.5* (fse3t(:,:,:) + fse3t_a(:,:,:) ) )  !  equivalent 'depth' at same time as tracer pool output
+      ELSE
+
+         IF( kt == nittrc000 ) THEN
+           ALLOCATE(trb_temp(jpi,jpj,jpk,jptra))  ! slwa
+         ENDIF
+         trb_temp(:,:,:,:)=trn(:,:,:,:) ! slwa save for tracer budget (unfiltered trn)
+
+!        DO jn = jp_myt0, jp_myt1
+!           cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
+!           CALL iom_put( cltra, trn(:,:,:,jn) ) 
+!        END DO
+! write out depths and areas in double precision for tracer budget calculations
+         CALL iom_put( "AREA" , e1t(:,:) * e2t(:,:))
+!        CALL iom_put( "DEPTH" , fse3t(:,:,:) )  ! need depth at same time as tracer output
+
+      END IF
+#else
       DO jn = jp_myt0, jp_myt1
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
          CALL iom_put( cltra, trn(:,:,:,jn) )
       END DO
+#endif
       !
    END SUBROUTINE trc_wri_my_trc
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 7567)
@@ -56,5 +56,5 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!
-      INTEGER            :: jn
+      INTEGER            :: jn, jk
       CHARACTER (len=22) :: charout
       REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd
@@ -105,4 +105,9 @@
         DO jn = 1, jptra
            ztrtrd(:,:,:,jn) = tra(:,:,:,jn) - ztrtrd(:,:,:,jn)
+#if defined key_tracer_budget
+           DO jk = 1, jpkm1
+             ztrtrd(:,:,jk,jn) = ztrtrd(:,:,jk,jn) * e1t(:,:) * e2t(:,:) * fse3t(:,:,jk)  ! slwa
+           END DO
+#endif
            CALL trd_tra( kt, 'TRC', jn, jptra_ldf, ztrtrd(:,:,:,jn) )
         END DO
Index: branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7566)
+++ branches/UKMO/CO6_shelfclimate/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 7567)
@@ -33,4 +33,7 @@
    USE trdtra
    USE tranxt
+   USE trcbdy          ! BDY open boundaries
+   USE bdy_par, only: lk_bdy
+   USE iom
 # if defined key_agrif
    USE agrif_top_interp
@@ -93,4 +96,7 @@
       CHARACTER (len=22) :: charout
       REAL(wp), POINTER, DIMENSION(:,:,:,:) ::  ztrdt 
+#if defined key_tracer_budget
+      REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  ztrdt_m1 ! slwa
+#endif
       !!----------------------------------------------------------------------
       !
@@ -101,4 +107,18 @@
          WRITE(numout,*) 'trc_nxt : time stepping on passive tracers'
       ENDIF
+#if defined key_tracer_budget
+      IF( kt == nittrc000 .AND. l_trdtrc ) THEN
+         ALLOCATE( ztrdt_m1(jpi,jpj,jpk,jptra) )  ! slwa
+         IF( ln_rsttr .AND.    &                     ! Restart: read in restart  file
+            iom_varid( numrtr, 'atf_trend_'//TRIM(ctrcnm(1)), ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) '          nittrc000-nn_dttrc ATF tracer trend read in the restart file'
+            DO jn = 1, jptra
+               CALL iom_get( numrtr, jpdom_autoglo, 'atf_trend_'//TRIM(ctrcnm(jn)), ztrdt_m1(:,:,:,jn) )   ! before tracer trend for atf
+            END DO
+         ELSE          
+           ztrdt_m1=0.0
+         ENDIF
+      ENDIF
+#endif
 
 #if defined key_agrif
@@ -111,7 +131,5 @@
 
 
-#if defined key_bdy
-!!      CALL bdy_trc( kt )               ! BDY open boundaries
-#endif
+      IF( lk_bdy )  CALL trc_bdy( kt )               ! BDY open boundaries
 
 
@@ -149,9 +167,37 @@
                zfact = 1.e0 / r2dt(jk)  
                ztrdt(:,:,jk,jn) = ( trb(:,:,jk,jn) - ztrdt(:,:,jk,jn) ) * zfact 
-               CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt )
+!slwa          CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt )
+#if defined key_tracer_budget
+               ztrdt(:,:,jk,jn) = ztrdt(:,:,jk,jn) * e1t(:,:) * e2t(:,:) * e3t_n(:,:,jk)  ! slwa vvl
+               !ztrdt(:,:,jk,jn) = ztrdt(:,:,jk,jn) * e1t(:,:) * e2t(:,:) * e3t_0(:,:,jk)  ! slwa CHANGE for vvl
+#endif
             END DO
+#if defined key_tracer_budget
+! slwa budget code
+              CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt_m1(:,:,:,jn) )
+#else
+              CALL trd_tra( kt, 'TRC', jn, jptra_atf, ztrdt(:,:,:,jn) )
+#endif
          END DO
+#if defined key_tracer_budget
+        ztrdt_m1(:,:,:,:) = ztrdt(:,:,:,:)    ! need previous time step for budget slwa
+#endif
          CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrdt ) 
       END IF
+
+#if defined key_tracer_budget
+      !                                           Write in the tracer restart file
+      !                                          *******************************
+      IF( lrst_trc ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'trc : ATF trend at last time step for tracer budget written in tracer restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         DO jn = 1, jptra
+            CALL iom_rstput( kt, nitrst, numrtw, 'atf_trend_'//TRIM(ctrcnm(jn)), ztrdt_m1(:,:,:,jn) )
+         END DO
+      ENDIF
+#endif
+
       !
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
